import { NgModule } from '@angular/core';
import { RouterModule, Routes } from '@angular/router';
import { ViewerComponent } from './viewer/viewer.component';
import { LoginComponent } from './login/login.component';
import { AuthGuardService } from './auth-guard.service';
import { NodeResolverService } from './node-resolver.service';

const routes: Routes = [
	{ path: '', component: LoginComponent, resolve: { response: NodeResolverService} },
	//{ path: 'create', component: PostCreateComponent, canActivate: [AuthGuardService]},
	{ path: 'view', component: ViewerComponent, canActivate: [AuthGuardService]},
	{ path: 'login', component: LoginComponent}
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule],
  providers: [AuthGuardService]
})
export class AppRoutingModule { }
